diff --git a/applications/imageviewer/package/contents/ui/FullScreenDelegate.qml b/applications/imageviewer/package/contents/ui/FullScreenDelegate.qml
index 92b40f3..c4b2af5 100644
--- a/applications/imageviewer/package/contents/ui/FullScreenDelegate.qml
+++ b/applications/imageviewer/package/contents/ui/FullScreenDelegate.qml
@@ -21,7 +21,7 @@ import QtQuick 1.0
 import org.kde.plasma.core 0.1 as PlasmaCore
 import org.kde.plasma.mobilecomponents 0.1 as MobileComponents
 import org.kde.qtextracomponents 0.1
-import Qt.labs.gestures 1.0
+import Qt.labs.gestures 2.0
 
 Flickable {
     id: mainFlickable
@@ -101,9 +101,13 @@ Flickable {
         clip: true
         GestureArea {
             anchors.fill: parent
-            onPinch: {
-                mainImage.scale = scaleFactor
+
+            Pinch {
+                onUpdated: {
+                    mainImage.scale *= gesture.scaleFactor
+                }
             }
+        }
 
             Image {
                 id: mainImage
@@ -148,6 +152,6 @@ Flickable {
                     }
                 }
             }
-        }
+        
     }
 }
diff --git a/applications/webbrowser/package/contents/ui/content/FlickableWebView.qml b/applications/webbrowser/package/contents/ui/content/FlickableWebView.qml
index ee936fb..9d31887 100644
--- a/applications/webbrowser/package/contents/ui/content/FlickableWebView.qml
+++ b/applications/webbrowser/package/contents/ui/content/FlickableWebView.qml
@@ -65,6 +65,8 @@ Flickable {
     anchors.left: parent.left
     anchors.right: parent.right
     pressDelay: 200
+    property Item view: webView
+
 
     onWidthChanged : {
         // Expand (but not above 1:1) if otherwise would be smaller that available width.
diff --git a/applications/webbrowser/package/contents/ui/webbrowser.qml b/applications/webbrowser/package/contents/ui/webbrowser.qml
index 9590d5a..0a07f2e 100644
--- a/applications/webbrowser/package/contents/ui/webbrowser.qml
+++ b/applications/webbrowser/package/contents/ui/webbrowser.qml
@@ -43,7 +43,7 @@ import QtQuick 1.0
 import org.kde.kdewebkit 0.1
 import org.kde.plasma.core 0.1 as PlasmaCore
 import org.kde.plasma.mobilecomponents 0.1 as MobileComponents
-import Qt.labs.gestures 1.0
+import Qt.labs.gestures 2.0
 
 import "content"
 
@@ -74,6 +74,23 @@ Rectangle {
         title: webView.title
     }
 
+    //FIXME: for Qt 4.8 this api will change
+    GestureArea {
+        anchors.fill: webView
+        Pinch {
+            onStarted: {
+               webView.view.renderingEnabled = false 
+            }
+            onUpdated: {
+                webView.view.contentsScale *= gesture.scaleFactor
+            }
+            onFinished: {
+                webView.view.renderingEnabled = true
+            }
+        }
+    }
+
+
     FlickableWebView {
         id: webView
         objectName: "webView"
@@ -88,14 +105,6 @@ Rectangle {
         }
     }
 
-    //FIXME: for Qt 4.8 this api will change
-    GestureArea {
-        anchors.fill: webView
-        onPinch: {
-            webView.doZoom(scaleFactor, centerPoint.x, centerPoint.y)
-        }
-    }
-
     Item { id: headerSpace; width: parent.width; height: header.height }
 
     Header {
